#ifndef COREL5K_H
#define COREL5K_H

class Corel5k{
	static const int trainImgNr = 4500;
	static const int testImgNr = 500;
	static const int classNr = 375;
	int clusterNum;
	int dim;
	int maxImgSize;
	char baseDir[256];
	char methodName[15];
	Method* currentMethod;

	float* hist;
	float* hists;
	int* imgnums;
	int ground_truth[trainImgNr+1][5];
	int test_gt[testImgNr][5];
	int* frec;
	char words[classNr][50];
	int* wh;
	int* wordcounts;
	float* weights;
	float* cooc;
	cv::Mat *centers;
	std::vector<std::vector<histbin>> shists;//sparse histograms
	//gmm* models;
public:
	Corel5k(const char* dir);
	void clean(int i);
	void readData();
	void cooccurrence();
	void saveDescr(float *X, int imgNum, float* hist=0);
	void saveHist(histbin *X, int imgNum);
	void loadCenter(int mnr,int imgnum, cv::Mat* centers, int index=0);
	void loadShist(int mnr, int imgnum, int index);
	void createDirectoryStructure();
	void trainAll();
	void trainImg(float* centers, char* imgName);
	void testAll();	
	void testImgMulti(float* descr, int imgnum, int labels[5], int index=0);
	void testImgMulti2(float* descr, int imgnum, int labels[5], int index=0);
	void saveAnnotation(int imgnum,int labels[5]);
	void results();	
};

#endif