#include "common.h";
#include "imgOperations.h"

extern params param;
#define LAB 1

double DCTM[8][8]={
		{0.3536,  0.3536,  0.3536,  0.3536,  0.3536,  0.3536,  0.3536,  0.3536},
		{0.4904,  0.4157,  0.2778,  0.0975, -0.0975, -0.2778, -0.4157, -0.4904},
		{0.4619,  0.1913, -0.1913, -0.4619, -0.4619, -0.1913,  0.1913,  0.4619},
		{0.4157, -0.0975, -0.4904, -0.2778,  0.2778,  0.4904,  0.0975, -0.4157},
		{0.3536, -0.3536, -0.3536,  0.3536,  0.3536, -0.3536, -0.3536,  0.3536},
		{0.2778, -0.4904,  0.0975,  0.4157, -0.4157, -0.0975,  0.4904, -0.2778},
		{0.1913, -0.4619,  0.4619, -0.1913, -0.1913,  0.4619, -0.4619,  0.1913},
		{0.0975, -0.2778,  0.4157, -0.4904,  0.4904, -0.4157,  0.2778, -0.0975}
	};
int indexes[64]={
	0, 8,1, 2,9,16, 24,17,10,3, 4,11,18,25,32, 40,33,26,19,12,5, 6,13,20,27,34,41,48, 56,49,42,35,28,21,14,7,
	15,22,29,36,43,50,57, 58,51,44,37,30,23, 31,38,45,52,59, 60,53,46,39, 47,54,61, 62,55, 63
};

class DCTMethod : Method{	
	int delta;
public:
	DCTMethod(int ddim){
		this->clusterNum=20;
		dim = ddim;
		sprintf(name,"DCT%d",dim);
		MethodRepo::instance()->add(name,this);
	}

//returns only the first D/3 elements from the coeficient matrix
//starts from the upper left corner based on indexes vector
void DCT(float* res,uchar* data,int w,int line,int col){
	int i,j,k,l;
	
	for(int nr=0;nr<dim/3;nr++){		
		i=indexes[nr]/8;
		j=indexes[nr]%8;		
		res[3*nr]=0;
		for(k=0;k<8;k++)
			for(l=0;l<8;l++)					
				res[3*nr]+=  data[(line+k)*w+col+3*l] * DCTM[i][k] * DCTM[j][l];  //res=DCT*(img)*DCT'	
	}	
};

//interleaves components in the following way:
// LabLabLab
void extractFeatures(float* B,int* nrKeypoints, IplImage* img){
	delta = 2;	
	IplImage *imgLab = cvCreateImage(cvGetSize(img),IPL_DEPTH_8U,3);
	if(LAB){
		cvCvtColor(img,imgLab,CV_BGR2Lab);
	}
	else{
		IplImage *tmp = imgToOCS(img);//tmp is 32bit img		
		cvConvertScale( tmp, imgLab, 0.5, 128);
		cvReleaseImage(&tmp);
	}
	//imgResize(&imgLab,192);
	//cvShowImage("Rasdas",imgLab);
	//cvWaitKey();
	int height    = imgLab->height;
	int width     = imgLab->width;
	int w					= imgLab->widthStep;//sizeof(uchar) is 1
	int channels  = imgLab->nChannels;
	uchar* data   = (uchar *)imgLab->imageData;
	
	*nrKeypoints=0;
	int i,j;
	for (i=0;i+7<height;i+=delta)
		for (j=0;j+7<width;j+=delta)			
		{	
			//find the n-th vector by concatenating the three color components
			DCT(B+dim* *nrKeypoints,		data,w,i,3*j+0); //L
			DCT(B+dim* *nrKeypoints+1,		data,w,i,3*j+1); //a
			DCT(B+dim* *nrKeypoints+2,		data,w,i,3*j+2); //b			
			(*nrKeypoints)++;						
		}	
		//printf(" delta: %d, samples: %d",delta,TT);		
	cvReleaseImage(&imgLab);
};

}_dct63(63),_dct192(192);